local mod = ...



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Pagan2.fbx/Prefab/StoneCircle1Part", "PREFAB_PAGAN_STONECIRCLE1")



-- Components -------------------------------------------------------------------------------------



-- Platform -------------------------------------------------------------------------------------
-- mod:configurePrefabFlagList("models/Pagan2.fbx/Prefab/StoneCircle1Part", { "PLATFORM" })



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/Pagan2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Grounding -------------------------------------------------------------------------------------
for i=1, 6, 1 do
	mod:registerPrefabComponent("models/Pagan2.fbx/Prefab/StoneCircle1Part/Stone." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 53, 1 do
	mod:registerPrefabComponent("models/Pagan2.fbx/Prefab/StoneCircle1Part/Pebble." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end



-- -- Particle: Fire -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "PARTICLE_SYSTEM",
-- 	Id = "PARTICLE_SYSTEM_STONECIRCLE_FIRE1",
-- 	Material = "MATERIAL_VOLCANO_FIRE",
-- 	BillboardBehavior = "FACE_CAMERA",
-- 	Duration = 10.0,
-- 	LifeTime = 8.0,
-- 	Looping = true,
-- 	Delay = { 0, 0 },
-- 	StartSpeed = { 0.1, 0.1 },
-- 	StartSize = { 20.0, 20.0 },
-- 	StartRotation = { 0, 0 },
-- 	StartColor = { 1, 1, 1, 1 },
-- 	GravityModifier = -0.01,
-- 	RateOverTime = 2,
--     RateOverTimeRandom = 2,
-- 	AlignWithVelocity = true,
-- 	Shape = {
-- 		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
-- 		Angle = 0.0,
-- 		-- Radius = 0.0001,
-- 		Radius = 0,
-- 	},
--     BurstList = {
--         {
--             DataType = "PARTICLE_BURST_DATA",
--             Time = 0,
--             Count = 2,
--             Cycles = 2,
--             Interval = 1.0,
--         },
--     },
-- 	LinearVelocity = {
-- 		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
-- 		ValueA = { 0.1, 0, 0.1 },
-- 		ValueB = { -0.1, 0, -0.1 }
-- 	},
-- 	ColorOverLifeTime = {
-- 		DataType = "GRADIENT",
-- 		ColorList = {
-- 			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
-- 			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
-- 			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
-- 			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
-- 		},
-- 		AlphaList = {
-- 			{ T = 0.1, Alpha = 10 },
-- 			{ T = 0.2, Alpha = 90 },
-- 			{ T = 0.3, Alpha = 0 },
-- 			{ T = 0.4, Alpha = 0 },
-- 			{ T = 0.5, Alpha = 90 },
-- 			{ T = 0.6, Alpha = 0 },
-- 			{ T = 0.7, Alpha = 40 },
-- 			{ T = 0.8, Alpha = 20 },
-- 			{ T = 0.9, Alpha = 10 },
-- 			{ T = 1, Alpha = 0 }
-- 		},
-- 	},
-- 	SizeOverLifetime = {
-- 			{ T = 0, Value = 0.1 },
-- 			{ T = 0.5, Value = 0.2 },
-- 			{ T = 1, Value = 0.3 }
-- 	},
-- 	RotationOverLifetime = { -70, 70 }
-- })

-- mod:registerPrefabComponent("models/Pagan2.fbx/Prefab/StoneCircle1Part/Emitter.001", {
-- 	DataType = "COMP_PARTICLE_EMITTER",
-- 	ParticleSystem = "PARTICLE_SYSTEM_STONECIRCLE_FIRE1",
-- 	IsPlaying = true,
-- 	IsEmitting = true
-- })



-- -- Particle: Smoke -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "PARTICLE_SYSTEM",
-- 	Id = "PARTICLE_SYSTEM_STONECIRCLE_SMOKE1",
-- 	Material = "MATERIAL_VOLCANO_SMOKE",
-- 	BillboardBehavior = "FACE_CAMERA",
-- 	Duration = 16,
-- 	LifeTime = 15,
-- 	Looping = true,
-- 	Delay = { 0, 0 },
-- 	StartSpeed = { 0.3, 0.3 },
-- 	StartSize = { 15.0, 15.0 },
-- 	StartRotation = { 0, 0 },
-- 	StartColor = { 1, 1, 1, 1 },
-- 	GravityModifier = -.015,
-- 	RateOverTime = 2,
-- 	Shape = {
-- 		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
-- 		Angle = 0.0,
-- 		Radius = 0.0001,
-- 	},
-- 	LinearVelocity = {
-- 		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
-- 		ValueA = { 0.15, 0, 0.15 },
-- 		ValueB = { -0.15, 0, -0.15 }
-- 	},
-- 	ColorOverLifeTime = {
-- 		DataType = "GRADIENT",
-- 		ColorList = {
-- 			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
-- 			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
-- 			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
-- 			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
-- 		},
-- 		AlphaList = {
-- 			{ T = 0.1, Alpha = 0 },
-- 			{ T = 0.2, Alpha = 20 },
-- 			{ T = 0.4, Alpha = 30 },
-- 			{ T = 0.6, Alpha = 40 },
-- 			{ T = 0.7, Alpha = 80 },
-- 			{ T = 0.8, Alpha = 30 },
-- 			{ T = 1, Alpha = 0 }
-- 		},
-- 	},
-- 	SizeOverLifetime = {
-- 			{ T = 0.1, Value = 0.2 },
-- 			{ T = 0.5, Value = 0.3 },
-- 			{ T = 1, Value = 0.5 }
-- 	},
-- 	RotationOverLifetime = { -25, 25 }
-- })

-- mod:registerPrefabComponent("models/Pagan2.fbx/Prefab/StoneCircle1Part/Emitter.002", {
-- 	DataType = "COMP_PARTICLE_EMITTER",
-- 	ParticleSystem = "PARTICLE_SYSTEM_STONECIRCLE_SMOKE1",
-- 	IsPlaying = true,
-- 	IsEmitting = true
-- })



-- Building Part: Stone Circle 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_PAGAN_STONECIRCLE1",
	Name = "BUILDING_PART_PAGAN_STONECIRCLE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PAGAN_STONECIRCLE1",
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = -1.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 25.0
        },
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 7.0, {0.0, 0.0}, 64 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
            -- { 
            --     Polygon = polygon.createCircle( 4.0, {0.0, 0.0}, 64 ),
            --     Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
			-- }, 
		}
	},
    Category = "CORE",
    Capacity = 30,
    AssetBuildingFunction = "BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM",
	Cost = {
        BuildRightTaxes = {	{ Resource = "STONE", Quantity = 80 } },
        -- UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
        -- RessourcesNeeded = {
        --     { Resource = "TOOL", Quantity = 5 },
		-- }
	},
    EstateSplendor = {
        { Estate = "CLERGY", Quantity = 1.00 },
    },
	DesirabilityModifiers = { 
        {
            Desirability = "DESIRABILITY_RESIDENTIAL",
            Type = "ADD",
            Radius = 25.0,
            Value = 0.5
    	} 
    },
})